/******************************************************************************
 * File: PropertyExceptions.h
 * Date: 14.1.2018
 *****************************************************************************/

#ifndef PROPERTYEXCEPTIONS_H
#define PROPERTYEXCEPTIONS_H

#include <QString>

#include "core/GrinderExceptions.h"

namespace grndr
{
	class PropertyBase;
	class PropertyObject;

	class PropertyException : public GrinderException
	{
	public:
		PropertyException(const PropertyBase* prop, QString what);

	public:
		const PropertyBase* property() const { return _property; }

	protected:
		const PropertyBase* _property{nullptr};
	};

	class PropertyItemException : public GrinderException
	{
	public:
		PropertyItemException(const PropertyObject* item, QString what);

	public:
		const PropertyObject* propertyItem() const { return _propertyItem; }

	protected:
		const PropertyObject* _propertyItem{nullptr};
	};
}

#endif
