/******************************************************************************
 * File: EvenOddConstraint.h
 * Date: 05.3.2018
 *****************************************************************************/

#ifndef EVENODDCONSTRAINT_H
#define EVENODDCONSTRAINT_H

#include "common/Range.h"
#include "common/properties/PropertyConstraint.h"

namespace grndr
{
	template<typename ValType>
	class EvenOddConstraint : public PropertyConstraint<ValType>
	{
	public:
		enum class Type
		{
			Even,
			Odd,
		};

	public:
		using value_type = typename PropertyConstraint<ValType>::value_type;

	public:
		EvenOddConstraint(Property<value_type>* property, Type type);

	public:
		virtual void applyConstraint(value_type& value);

	public:
		Type getType() const { return _type; }
		void setType(Type type) { _type = type; }

	private:
		Type _type{Type::Even};
	};
}

#include "EvenOddConstraint.impl.h"

#endif
