/******************************************************************************
 * File: RangeConstraint.h
 * Date: 05.3.2018
 *****************************************************************************/

#ifndef RANGECONSTRAINT_H
#define RANGECONSTRAINT_H

#include "common/Range.h"
#include "common/properties/PropertyConstraint.h"

namespace grndr
{
	template<typename ValType>
	class RangeConstraint : public PropertyConstraint<ValType>
	{
	public:
		using value_type = typename PropertyConstraint<ValType>::value_type;

	public:
		RangeConstraint(Property<value_type>* property, const value_type& minValue, const value_type& maxValue);

	public:
		virtual void applyConstraint(value_type& value);

	public:
		Range<value_type>& range() { return _range; }
		const Range<value_type>& range() const { return _range; }

	private:
		Range<value_type> _range;
	};
}

#include "RangeConstraint.impl.h"

#endif
