/******************************************************************************
 * File: EnumProperty.h
 * Date: 05.6.2018
 *****************************************************************************/

#ifndef ENUMPROPERTY_H
#define ENUMPROPERTY_H

#include "EnumPropertyBase.h"

namespace grndr
{
	template<typename EnumType>
	class EnumProperty : public EnumPropertyBase
	{
	public:
		using enum_type = EnumType;

	public:
		using EnumPropertyBase::EnumPropertyBase;

		EnumProperty& operator =(enum_type val) { _value = static_cast<value_type>(val); return *this; }

		operator enum_type() const { return getValue(); }

		bool operator ==(enum_type val) const { return getValue() == val; }

	public:
		enum_type getValue() const { return static_cast<enum_type>(_value); }
		void setValue(enum_type val) { setValue(static_cast<value_type>(val)); }

	public:
		auto& operator [](enum_type val) { return _enumMap[val]; }
		auto& operator [](enum_type val) const { return _enumMap.at(val); }

		virtual std::map<int, QString> enumValues() const override;

	public:
		virtual QString toString() const override;

	protected:
		std::map<enum_type, QString> _enumMap;
	};
}

#include "EnumProperty.impl.h"

#endif
