/******************************************************************************
 * File: EnumProperty.impl.h
 * Date: 05.6.2018
 *****************************************************************************/

#include "Grinder.h"
#include "EnumProperty.h"

template<typename EnumType>
std::map<int, QString> EnumProperty<EnumType>::enumValues() const
{
	std::map<int, QString> values;

	for (const auto& enumEntry : _enumMap)
		values[static_cast<int>(enumEntry.first)] = enumEntry.second;

	return values;
}

template<typename EnumType>
QString EnumProperty<EnumType>::toString() const
{
	auto it = _enumMap.find(getValue());

	if (it != _enumMap.cend())
		return it->second;
	else
		return "";
}
