/******************************************************************************
 * File: DeserializationContext.cpp
 * Date: 28.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "DeserializationContext.h"

DeserializationContext::DeserializationContext(const SettingsContainer& settings, Mode mode) : SerializationBase(mode),
	_settings{settings}
{

}

bool DeserializationContext::beginGroup(QString name)
{
	if (auto child = settings().child(name))
	{
		_settingsStack.push(child);
		return true;
	}
	else
		return false;
}

void DeserializationContext::addImageSearchPaths(const QStringList& searchPaths)
{
	_imageSearchPaths.append(searchPaths);
	_imageSearchPaths.removeDuplicates();
}
