/******************************************************************************
 * File: SerializationContext.cpp
 * Date: 28.2.2018
 *****************************************************************************/

#include "Grinder.h"
#include "SerializationContext.h"
#include "pipeline/ConnectionVector.h"

SerializationContext::SerializationContext(QString rootName, Mode mode, const SettingsContainer* settings) : SerializationBase(mode),
	_settings{rootName}
{
	if (settings)
		_settings = *settings;
}

void SerializationContext::endGroup()
{
	// Remove the top group from the stack and add it to the preceding container
	auto currentSettings = std::move(_settingsStack.top());
	_settingsStack.pop();
	settings() << currentSettings;
}

void SerializationContext::addConnection(const Connection* con)
{
	if (std::find(_connections.cbegin(), _connections.cend(), con) == _connections.cend())
		_connections.push_back(con);
}
